unit Antialiasing_ej1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    img1: TImage;
    btn1: TButton;
    pbMain: TProgressBar;
    OpenD: TOpenPictureDialog;
    Label1: TLabel;
    img4: TImage;
    img3: TImage;
    Label3: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    sb1: TStatusBar;
    procedure btn1Click(Sender: TObject);
    procedure img1Click(Sender: TObject);
  private
    function _NewColor1(C:TCanvas;X,Y:integer): TColor;
    function _NewColor2(C:TCanvas;X,Y:integer): TColor;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function TForm1._NewColor1(C:TCanvas;X,Y:integer): TColor;
var
  r1,g1,b1:Integer;
  r2, g2,b2:Integer;
  r3, g3,b3:Integer;
begin

  R1 := GetRValue(c.Pixels[X,Y]);
  G1 := GetGValue(c.Pixels[X,Y]);
  B1 := GetBValue(c.Pixels[X,Y]);
  R2 := GetRValue(c.Pixels[X,Y-1]);
  G2 := GetGValue(c.Pixels[X,Y-1]);
  B2 := GetBValue(c.Pixels[X,Y-1]);
  R3 := GetRValue(c.Pixels[X,Y+1]);
  G3 := GetGValue(c.Pixels[X,Y+1]);
  B3 := GetBValue(c.Pixels[X,Y+1]);

  // PONDERANDO MEJOR (*4)
  R1:=Round(R1 + R2 + r3 ) div 3;
  G1:=Round(G1 + G2 + g3 ) div 3;
  B1:=Round(B1 + B2 + b3 ) div 3;

  Result := RGB(R1,G1,B1);
end;

function TForm1._NewColor2(C:TCanvas;X,Y:integer): TColor;
var
  r1,g1,b1:Integer;
  r2, g2,b2:Integer;
  r3, g3,b3:Integer;
  r4, g4,b4:Integer;
  r5, g5,b5:Integer;
begin

  R1 := GetRValue(c.Pixels[X,Y]);
  G1 := GetGValue(c.Pixels[X,Y]);
  B1 := GetBValue(c.Pixels[X,Y]);
  R2 := GetRValue(c.Pixels[X,Y-1]);
  G2 := GetGValue(c.Pixels[X,Y-1]);
  B2 := GetBValue(c.Pixels[X,Y-1]);
  R3 := GetRValue(c.Pixels[X,Y+1]);
  G3 := GetGValue(c.Pixels[X,Y+1]);
  B3 := GetBValue(c.Pixels[X,Y+1]);

  R4 := GetRValue(c.Pixels[X+1,Y]);
  G4 := GetGValue(c.Pixels[X+1,Y]);
  B4 := GetBValue(c.Pixels[X+1,Y]);
  R5 := GetRValue(c.Pixels[X-1,Y]);
  G5 := GetGValue(c.Pixels[X-1,Y]);
  B5 := GetBValue(c.Pixels[X-1,Y]);


  R1:=Round(R1 + R2 + r3 + r4 + r5) div 5;
  G1:=Round(G1 + G2 + g3 + g4 + g5) div 5;
  B1:=Round(B1 + B2 + b3 + b4 + b5) div 5;

  Result := RGB(R1,G1,B1);
end;


procedure TForm1.btn1Click(Sender: TObject);
var
  X,Y:Integer;
  newColor:integer;
  C1, C3, C4:TCanvas;
  fName:string;
begin


  if not Assigned(img3.Picture.Bitmap) then begin
    img3.Picture.Bitmap := TBitmap.Create();
  end;
  img3.Picture.Bitmap.Height := img1.Picture.Bitmap.Height;
  img3.Picture.Bitmap.Width := img1.Picture.Bitmap.Width;

  if not Assigned(img4.Picture.Bitmap) then begin
    img4.Picture.Bitmap := TBitmap.Create();
  end;
  img4.Picture.Bitmap.Height := img1.Picture.Bitmap.Height;
  img4.Picture.Bitmap.Width := img1.Picture.Bitmap.Width;


  Application.ProcessMessages;

  C1 := img1.Picture.Bitmap.Canvas;
  C3 := img3.Picture.Bitmap.Canvas;
  C4 := img4.Picture.Bitmap.Canvas;

  pbMain.Min := 0;
  pbMain.Max := img1.Picture.Bitmap.Height;


  for Y := 1 to (img1.Picture.Bitmap.Height - 1) do begin
    pbMain.Position := Y;
    Application.ProcessMessages;
    
    for X := 1 to (img1.Picture.Bitmap.Width - 1) do begin

      newcolor := _NewColor1(C1, X, Y);
      C3.Pixels[X, Y] := newColor;

      newcolor := _NewColor2(C1, X, Y);
      C4.Pixels[X, Y] := newColor;

    end;
  end;

  fName := ExtractFilePath(Application.ExeName) + 'tmp2.bmp';
  img3.Picture.Bitmap.SaveToFile(fName);

  fName := ExtractFilePath(Application.ExeName) + 'tmp4.bmp';
  img4.Picture.Bitmap.SaveToFile(fName);

end;


procedure TForm1.img1Click(Sender: TObject);
begin

  OpenD.InitialDir := ExtractFilePath(Application.ExeName);
  if OpenD.Execute then begin
    img1.Picture.Bitmap.LoadFromFile(OpenD.FileName);
    btn1.Enabled := true;
  end;

end;

end.

